noop = -> yield return

###
# Compose `middleware` returning
# a fully valid middleware comprised
# of all those which are passed.
#
# @param {Array} middleware
# @return {Function}
# @api public
###
module.exports = (middleware)-> (req, res, next)->
	i       = middleware.length
	context = {}
	next   ?= noop
	next    = middleware[i].call(context, req, res, next) while i -= 1
	yield next
